/*

behavioural layer for the `change_password.html.tera` template

 - intercept button click for save (form submission of passwords)
 - perform json api call
 - update the dom

methods:

 PEACH_AUTH.changePassword();

*/

var PEACH_AUTH = {};

// catch click of 'Save' button and make POST request
PEACH_AUTH.changePassword = function() {
    document.addEventListener('DOMContentLoaded', function() {
        document.body.addEventListener('submit', function(e) {
            // prevent redirect on button press (default behavior)
            e.preventDefault();
            // capture form data
            var formElement = document.querySelector("form");
            // create form data object from the changePassword form element
            var formData = new FormData(formElement);
            var object = {};
            // assign values from form
            formData.forEach(function(value, key){
                object[key] = value;
            });
            // perform json serialization
            console.log(object);
            var jsonData = JSON.stringify(object);
            // write in-progress status message to ui
            PEACH.flashMsg("info", "Saving new password.");
            // send change_password POST request
            fetch("/api/v1/admin/change_password", {
                method: "post",
                headers: {
                    'Content-Type': 'application/json',
                },
                body: jsonData
            })
            .then( (response) => {
                return response.json()
            })
            .then( (jsonData) => {
                // write json response message to ui
                PEACH.flashMsg(jsonData.status, jsonData.msg);
            })
        }, false);
    });
}

var changePassInstance = PEACH_AUTH;
changePassInstance.changePassword();
